%global version_major 8
%global version_minor 4
%global version_micro 0
%global commitid JDG_7.1.0.Final-3-BOTH
%global serial 3

Name:           jdg-cpp-client
Version:	8.4.0.Final
Release:	%{serial}%{?dist}
Patch1: 	disable-maven-build.patch
Summary:        JBoss Data Grid HotRod C++ client
Group:          System Environment/Libraries
License:        ASL 2.0
URL:            https://www.redhat.com/en/technologies/jboss-middleware/data-grid
Source0:        jdg-cpp-client-%{commitid}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: cmake
BuildRequires: doxygen
BuildRequires: valgrind
BuildRequires: java-1.8.0-openjdk-devel swig
%if 0%{?rhel} != 6
BuildRequires: openssl-devel
BuildRequires: protobuf-devel protobuf-static
%endif

%if 0%{?rhel} != 6
Requires: openssl-devel
Requires: protobuf-devel protobuf-static
%endif

%description
JBoss Data Grid HotRod C++ client

%files
%defattr(-,root,root,-)
%dir %_includedir/infinispan
%_includedir/infinispan/hotrod
%_libdir/libhotrod.so
%_libdir/libhotrod.so.*
%_libdir/libhotrod-static.a
%_docdir/infinispan-hotrod-cpp
%if 0%{?rhel} != 6
%_libdir/libhotrod_protobuf.a
%endif

%package tests
Summary: JBoss Data Grid C++ client test files

%description tests
JBoss Data Grid C++ client test files

%files tests
%defattr(-,root,root,-)
%_datadir/tests/unittest*
%_datadir/tests/simple*
%_prefix/jni/hotrod-jni.jar
%_prefix/jni/libhotrod-jni.so
%if 0%{?rhel} != 6
%_datadir/tests/queryTest*
%_datadir/tests/events*
%endif

%prep
%setup -q -n jdg-cpp-client-%{commitid}
%if 0%{?rhel} == 6
pushd rhel6
%else
pushd rhel7
%endif 
%patch1 -p0
popd

%build

%ifarch i386
export CXXFLAGS="-march=i686"
%endif

env
mkdir _rpmbuild
pushd _rpmbuild
%if 0%{?rhel} == 6
%cmake  -DCMAKE_BUILD_TYPE=RelWithDebInfo ../rhel6
%else
%cmake  -DCMAKE_BUILD_TYPE=RelWithDebInfo -DPROTOBUF_LIBRARY=%{_libdir}/libprotobuf.a ../rhel7
%endif
make 
popd

%install
rm -rf %{buildroot}
pushd _rpmbuild
%make_install
mkdir -p %{buildroot}/%_datadir/tests
cp unittest* simple* %{buildroot}/%_datadir/tests -r
%if 0%{?rhel} != 6
cp queryTest* events* %{buildroot}/%_datadir/tests -r
%endif
popd

%clean
rm -rf %{buildroot}

%check
# TODO

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%changelog
* Thu Apr 13 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.Final-3
- JDG_7.1.0.Final-3-BOTH / JDG_7.1.0.CR3-BOTH

* Wed Apr 12 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.Final-15
- JDG_7.1.0.Final-3-BOTH / JDG_7.1.0.CR3-BOTH

* Thu Apr 06 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.Final-15
- 

* Tue Mar 28 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.Final-15
- 

* Tue Mar 14 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.ER7-15
- 

* Mon Feb 27 2017 jsenko <jsenko@redhat.com> - 8.3.0.Final3-2
- 8.3.0.Final3

* Mon Feb 27 2017 jsenko <jsenko@redhat.com> - 8.3.0.Final3-1
- 8.3.0.Final3

* Mon Feb 27 2017 jsenko <jsenko@redhat.com> - 8.3.0.Final-redhat-3-2
- 8.3.0.Final-redhat-3

* Mon Feb 27 2017 jsenko <jsenko@redhat.com> - 8.3.0.Final-redhat-3-1
- 8.3.0.Final-redhat-3

* Fri Feb 24 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.ER6-15
- 

* Thu Feb 16 2017 Sebastian Laskawiec <slaskawi@redhat.com> - 8.3.0.CR2-2
- 8.3.0.CR2

* Thu Feb 16 2017 Sebastian Laskawiec <slaskawi@redhat.com> - 8.3.0.CR2-1
- 8.3.0.CR2

* Thu Feb 16 2017 Sebastian Laskawiec <slaskawi@redhat.com> - 8.3.0.Final-1
- 8.3.0.Final

* Thu Feb 16 2017 Sebastian Laskawiec <slaskawi@redhat.com> - 8.3.0.Final-2-2
- 8.3.0.Final-2

* Thu Feb 16 2017 Sebastian Laskawiec <slaskawi@redhat.com> - 8.3.0.Final-2-1
- 8.3.0.Final-2

* Mon Feb 13 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.ER5-14
- JDG 7.1.0.ER5

* Mon Jan 30 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.ER4-13
- JDG 7.1.0.ER4

* Thu Jan 12 2017 Jakub Senko <jsenko@redhat.com> - 8.4.0.ER3-12
- JGD 7.1.0.ER3

* Mon Dec 19 2016 Vaclav Dedik <vdedik@redhat.com> - 8.4.0.ER2-11
- Rhel 7 only:
  - Near cache implementation

* Thu Dec 01 2016 Vaclav Dedik <vdedik@redhat.com> - 8.4.0.ER1-10
- Fix RPM diff error and at the same time build swig generated java sources

* Thu Dec 01 2016 Vaclav Dedik <vdedik@redhat.com> - 8.4.0.ER1-9
- Build tests as well and package it as jdg-cpp-client-tests*.rpm
- RHEL7 only:
  - Remote queries feature

* Tue Nov 22 2016 Vaclav Dedik <vdedik@redhat.com> - 8.4.0.DR3-8
- Fix JDG-568/HRCPP-319/Remove include of Transport.h in CacheClientListener.h
- RHEL 7 only:
  - HRCPP-322 # Cluster switch methods now same as Java
  - HRCPP-320 # Fixed mem leak in marshaller
  - HRCPP-237 # Fix for MSVC error
  - HRCPP-234 # added Expired Entry event

* Thu Nov 03 2016 Vaclav Dedik <vdedik@redhat.com> - 8.4.0.DR2-7
- RHEL7 only:
  - HRCPP-310 # gitattributes to have only LF
  - HRCPP-297 # SNI Implementation for openSSL and schannel
  - HRCPP-312 # Fixed default value for forcedReturnValue
  - HRCPP-315 # Pass failed servers to balancing
  - HRCPP-316 Refactored socket and transport
  - HRCPP-287 # Events framework

* Fri Oct 21 2016 Vaclav Dedik <vdedik@redhat.com> - 8.4.0.DR1-6
- HRCPP-286 (xSite failover)

* Tue Oct 04 2016 Fernando Nasser <fnasser@redhat.com> - 8.4.0.DR1-5
- Get the RHEL-7 sources straight from the Git sources repo

* Tue Oct 04 2016 Fernando Nasser <fnasser@redhat.com> - 8.4.0.DR1-3
- Plain rebuild to confirm build system setup

* Tue Oct 04 2016 Fernando Nasser <fnasser@redhat.com> - 8.4.0.DR1-2
- Update to the latest in the jdg-7.1.x and jdg-7.1.x-RHEL6 branches

* Mon Oct 03 2016 Fernando Nasser <fnasser@redhat.com> - 8.4.0.DR1-1
- Test build setup

* Thu Sep 22 2016 vdedik <vdedik@redhat.com> - 8.4.0.DR1-1
- Preparing for 8.4.0.DR1
